/* src/main.h - Dclarations principales
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: main.h,v 1.78 2003/12/28 23:43:17 romexzf Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "../config.h"
#include "token.h"
#include "lang.h"

/*#define SQLLOG*/
#ifdef TESTBOT /* En effet, la version avec le web2cs c la version 2 :)*/

#define SPVERSION "1.2.0"
#else
#define SPVERSION "1.1.9"
#endif

#define CTCP_DELIM_CHAR '\001'
#define MAXPARA 16
#define MAXLEN 512

#define NICKLEN 30
#define TOPICLEN 250
#define HOSTLEN 63
#define REALEN 50
#define USERLEN 10
#define KEYLEN 23
#define CHANLEN 200
#define REGCHANLEN 100
#define DESCRIPTIONLEN 80
#define NUHLEN (NICKLEN + USERLEN + HOSTLEN + 3)
#define MAILLEN 99
#define OWNERLEVEL 500 /* vous pouvez dfinir le niveau max dans un salon, mais, aprs ne le changer pas
						si vous avez une db active !! vous feriez ignorer tous les accs owner. */

/*si vous ne voulez pas tout logger, mettez rien entre les "" des diffrents fichiers*/
#define WAIT_DEL_PARSES 172800 /* Temps au bout duquel SCoderZ attend avant de del LOG_PARSES (172800 = 2 jours)*/
#define WAIT_DEL_LOGS 864000 /* Temps au bout duquel SCoderZ attend avant de del les autres fichiers de logs (864000 = 10 jours)*/
#define USERS_FILE DBDIR"/usr.db"
#define USRS_VERSION 20 /* version actuelle des fichiers ATTENTION: NE PAS CHANGER risque important de detruire la db*/
#define BADCHANS_FILE DBDIR"/badchans.db"
#define CHANS_FILE DBDIR"/chans.db"
#define WELCOME_FILE DBDIR"/welcome.db"
#define SETWELCOME_FILE DBDIR"/setwelcome.db"
#define BADNICKS_FILE DBDIR"/badnicks.db"
#define CMDS_FILE DBDIR"/cmds.db"
#define VOTE_FILE DBDIR"/votes.db"
#define REGISTER_TIMEOUT 86400 /* temps apres lequel un nick est purge si personne ne s'est auth lors de la procedure de register*/
#define PING_FREQ 90 /* interval des pings */
#define ALARMINTERVAL 25 /* interval de l'alarme (si Z rame beaucoup.. l'augmenter)*/
#define SCODERZ_PID "scoderz.pid" /* fichier o sera stock le n de pid de scoderz */
#define CANTREGONUNREG 10800 /* temps en secondes apres un unreg empechant un nouveau register*/

#define WAIT_CONNECT 10 /* Temps qu'attend le serveur avant de retenter une connexion */
#define MODE_OBV 0x1

#define IsAnAdmin(x) 	((x) && (x)->level > 1) /* x est un admin ? */
#define IsOper(x) 		((x)->flag & N_OPER)

#ifdef N2K
#	define MAXNUM 4096
#	define NUMSERV 2
#else
#	define MAXNUM 64
#	define NUMSERV 1
#endif

#include <structs.h>

#define AOp(x)		 ((x)->flag & A_OP)
#define AVoice(x)	 ((x)->flag & A_VOICE)
#define ASuspend(x)	 ((x)->flag & A_SUSPEND)
#define AProtect(x)	 ((x)->flag & A_PROTECT)
#define AWait(x) ((x)->flag & A_WAITACCESS)
#define SetAOp(x)	 ((x)->flag |= A_OP)
#define SetAVoice(x)	 ((x)->flag |= A_VOICE)
#define SetAProtect(x)	 ((x)->flag |= A_PROTECT)
#define SetASuspend(x)	 ((x)->flag |= A_SUSPEND)
#define DelAOp(x)	 ((x)->flag &= ~A_OP)
#define DelAVoice(x)	 ((x)->flag &= ~A_VOICE)
#define DelAProtect(x)	 ((x)->flag &= ~A_PROTECT)
#define DelASuspend(x)	 ((x)->flag &= ~A_SUSPEND)

#define NRegister(x)	 ((x)->flag & N_REGISTER)
#define SetNRegister(x)	 ((x)->flag |= N_REGISTER)
#define DelNRegister(x)	 ((x)->flag &= ~N_REGISTER)

#ifdef USE_NICKSERV
#define UPKill(x)	 ((x)->flag & U_PKILL)
#define UPNick(x)	 ((x)->flag & U_PNICK)
#define SetUPKill(x)	 ((x)->flag |= U_PKILL)
#define SetUPNick(x)	 ((x)->flag |= U_PNICK)
#define DelUPKill(x)	 ((x)->flag &= ~U_PKILL)
#define DelUPNick(x)	 ((x)->flag &= ~U_PNICK)
#define IsProtected(x)	 ((x)->flag & (U_PNICK | U_PKILL))
#endif /* USE_NICKSERV */

#define UWantDrop(x)	 ((x)->flag & U_WANTDROP)
#define UWantX(x)	 ((x)->flag & U_WANTX)
#define UNopurge(x)	 ((x)->flag & U_NOPURGE)
#define UOubli(x)	 ((x)->flag & U_OUBLI)
#define UFirst(x)	 ((x)->flag & U_FIRST)
#define UNoMemo(x)	 ((x)->flag & U_NOMEMO)
#define SetUWantX(x)	 ((x)->flag |= U_WANTX)
#define SetUNopurge(x)	 ((x)->flag |= U_NOPURGE)
#define SetUOubli(x)	 ((x)->flag |= U_OUBLI)
#define SetUFirst(x)	 ((x)->flag |= U_FIRST)
#define SetUNoMemo(x)	 ((x)->flag |= U_NOMEMO)
#define DelUWantX(x)	 ((x)->flag &= ~U_WANTX)
#define DelUNopurge(x)	 ((x)->flag &= ~U_NOPURGE)
#define DelUOubli(x)	 ((x)->flag &= ~U_OUBLI)
#define DelUFirst(x)	 ((x)->flag &= ~U_FIRST)
#define DelUNoMemo(x)	 ((x)->flag &= ~U_NOMEMO)

#define CSetWelcome(x)		((x)->flag & C_SETWELCOME)
#define CJoined(x)		((x)->flag & C_JOINED)
#define CStrictOp(x)		((x)->flag & C_STRICTOP)
#define CLockTopic(x)		((x)->flag & C_LOCKTOPIC)
#define CNoBans(x)		((x)->flag & C_NOBANS)
#define CWantUnreg(x)		((x)->flag & C_WANTUNREG)
#define CNoOps(x)		((x)->flag & C_NOOPS)
#define CAutoInvite(x)		((x)->flag & C_AUTOINVITE)
#define CFLimit(x)			((x)->flag & C_FLIMIT)
#define SetCSetWelcome(x)	((x)->flag |= C_SETWELCOME)
#define SetCJoined(x)		((x)->flag |= C_JOINED)
#define SetCStrictOp(x)		((x)->flag |= C_STRICTOP)
#define SetCLockTopic(x)	((x)->flag |= C_LOCKTOPIC)
#define SetCNoBans(x)		((x)->flag |= C_NOBANS)
#define SetCWantUnreg(x)	((x)->flag |= C_WANTUNREG)
#define SetCNoOps(x)		((x)->flag |= C_NOOPS)
#define DelCSetWelcome(x)	((x)->flag &= ~C_SETWELCOME)
#define DelCJoined(x)		((x)->flag &= ~C_JOINED)
#define DelCStrictOp(x)		((x)->flag &= ~C_STRICTOP)
#define DelCLockTopic(x)	((x)->flag &= ~C_LOCKTOPIC)
#define DelCNoBans(x)		((x)->flag &= ~C_NOBANS)
#define DelCWantUnreg(x)	((x)->flag &= ~C_WANTUNREG)
#define DelCNoOps(x)		((x)->flag &= ~C_NOOPS)

#define IsOp(x) 		((x)->status & J_OP)
#define IsVoice(x) 		((x)->status & J_VOICE)
#define DoOp(x) 		((x)->status |= J_OP)
#define DoVoice(x) 		((x)->status |= J_VOICE)
#define DeOp(x) 		((x)->status &= ~J_OP)
#define DeVoice(x) 		((x)->status &= ~J_VOICE)

#define ChanCmd(x) (cs_cmds[(x)].flag & CMD_CHAN)
#define AdmCmd(x) (cs_cmds[(x)].flag & CMD_ADMIN)

#define GetConf(x) (ConfFlag & (x))
#define ASIZE(x) (sizeof (x) / sizeof *(x))

#define IsSuspend(x) ((x)->suspend && (!(x)->suspend->expire ||\
						((x)->suspend->debut + (x)->suspend->expire) > time(NULL)))

#define CantRegChan(x) (!(x)->cantregchan || (x)->cantregchan > time(NULL))

#define NOSUCHUSER "\002%s\2 n'est pas un Username enregistr."
#define NOSUCHAN "\002%s\2 n'est pas un salon enregistr."
#define NOTCONNECTED "%s n'est pas connect."
#define PLUR(x) ((x) > 1 ? "s" : "")
#define PLURX(x) ((x) > 1 ? "x" : "")
#define NONE(x) ((x) ? (x) : "")

#define SPECIAL_CHAR "{}[]|-_\\^`"

/* global vars*/
extern struct robot bot;
#ifdef USE_WELCOMESERV
extern struct bots ws;
extern char user_motd[];
extern char admin_motd[];
#endif
extern int ConfFlag;
extern struct cs_commands cs_cmds[];
extern int cs_cmds_size;
extern struct bots cs;
extern anUser *user_tab[];
extern aChan *chan_tab[];
extern aNick **num_tab[];
extern aServer *serv_tab[];
extern aNick *nick_tab[];

extern int lastresetparse;
extern int want_to_quit;

extern struct badchans *badchead;
extern struct killinfo *killhead;
extern struct badnicks *badnhead;
extern struct ignore *ignorehead;

extern Lang *DefaultLang;
static inline char *GetReply(aNick *nick, int msgid)
{
	Lang *lang = nick->user ? nick->user->lang : DefaultLang;
	return lang->msg[msgid] ? lang->msg[msgid] : DefaultLang->msg[msgid];
}

/**** CONFIGURATIONS PAR DEFAUT ****/
/* A METTRE SOUS LA FORME: #define U|C_DEFAULT (FLAG1 | FLAG2 | ... FLAGn) */

/* Salons
	C_SETWELCOME 	envoi du welcome
	C_STRICTOP 		ops avec accs seulement
	C_LOCKTOPIC		topic bloqu
	C_NOBANS		pas de bans possibles
	C_NOOPS			pas de nouveaux ops
	C_AUTOINVITE 	invite auto au login si chan +kirl
	C_FLIMIT 		limite flottante (paramtres dfinissables plus bas)
*/

#define C_DEFAULT 0
#define C_DEFMODES (C_MMSG | C_MTOPIC)

#define DEFAUT_LIMITINC 3
#define DEFAUT_LIMITMIN 3
#define DEFAUT_BANLEVEL 300
#define DEFAUT_CMODELEVEL 300
#define C_DEFAULT_BANTYPE 1

/* Usernames
	U_PKILL 	protection par kill
	U_PNICK		protection par chnick
	U_NOPURGE 	non concern par l'expiration auto
	U_WANTX		auto +x au login
	U_NOMEMO	rejette les mmos

	1 parmi les 3 suivants pour la politique vis  vis des accs
	U_PREJECT	rejette
	U_POKACCESS	demande confirmation
	U_PACCEPT 	accepte
*/

#define U_DEFAULT U_POKACCESS
