/* src/cs_cmds.c commandes IRC du CS
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs_and_davidounet@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: cs_cmds.c,v 1.12 2003/12/28 01:07:32 romexzf Exp $
 */

#include "main.h"
#include "cs_cmds.h"
#include "outils.h"
#include "hash.h"
#include <stdarg.h>
#include <sys/socket.h>

void putserv(const char *fmt, ...)
{
	char buf[512] = {0};
	int len;
	va_list vl;

	va_start(vl, fmt);
	len = vsnprintf(buf, sizeof buf - 2, fmt, vl);
	va_end(vl);

	len = len > 0 ? len : sizeof buf - 2;

#ifdef DEBUG
	if(strncmp(&buf[NUMSERV+1], TOKEN_PONG, 9-4*NUMSERV) && strncmp(&buf[NUMSERV+1], TOKEN_PING, 9-4*NUMSERV))
    putlog(LOG_PARSES, "S - %s", buf);
#endif

	buf[len++] = '\r';
	buf[len++] = '\n';
	send(bot.sock, buf, len, 0);
	bot.dataS += len;
	return;
}

static const char *table_dec = "0123456789";

int csntc(aNick *nick, register const char *fmt, ...)
{/* APACS N YYXXX :f*/
	static char buf[512];
	register char *p = buf;
	char t, *end = p + 509;
	int len = 0;
	va_list vl;

	va_start(vl, fmt);

#ifdef N2K
	if(buf[0] == 0)
	{
		strcpy(p, cs.num);
		p[5] = p[7] = p[13] = ' ';
		p[6] = TOKEN_NOTICE[0];
		p[14] = ':'; /* prefix, cmd, cible, parser format*/
	}
	p += 15;
	buf[8] = nick->numeric[0];
	buf[9] = nick->numeric[1];
	buf[10] = nick->numeric[2];
	buf[11] = nick->numeric[3];
	buf[12] = nick->numeric[4];
#else
	strcpy(p, cs.num);
	p[3] = p[10] = p[15] = ' ';
	strcpy(p + 4, TOKEN_NOTICE);
	strcpy(p + 11, nick->numeric);
	p += 16; *p++ = ':';
#endif

	while((t = *fmt++) && p < end)/* %sa (t = %, *pattern = s)*/
	{
		if(t == '%')
		{
			t = *fmt++;/* on drop le formateur (t = s, *pattern = a)*/
			if(t == 's')
			{	/* copie de la string*/
				register char *tmps = va_arg(vl, char *);
				while(*tmps) *p++ = *tmps++;
				continue;
			}
			if(t == 'd')
			{
				int tmpi = va_arg(vl, int), pos = 31;
				char bufi[32];

				if(tmpi <= 0)
				{
					if(!tmpi)
					{
						*p++ = '0';
						continue;
					}
					*p++ = '-';
					tmpi = -tmpi;
				}
				while(tmpi)/* on converti une int en base 10 en string */
				{		/* criture dans l'ordre inverse 51 > '   1' > '  51'*/
					bufi[pos--] = table_dec[tmpi % 10];
					tmpi /= 10;
				}
				while(pos < 31) *p++ = bufi[++pos];
				continue;
			}
			if(t == 'c')
			{
				*p++ = (char) va_arg(vl, int);
				continue;
			}
			if(t != '%')
			{/* on sous traite le reste  vsnprintf */
				int i = vsnprintf(p, sizeof buf - (p - end + 509), fmt - 2, vl);/* on remet le %format*/
				p += i > 0 ? i : sizeof buf - (p - end + 509);
				break;
			}
		}
		*p++ = t;
	}
	*p++ = '\r';
	*p++ = '\n';
	*p = '\0';

	len = p - end + 509;
	send(bot.sock, buf, len, 0);
	bot.dataS += len;
	va_end(vl);
	return 0;
}

void putchan(const char *buf)
{
	time_t tmt = time(NULL);
	struct tm *ntime = localtime(&tmt);

	putserv("%s " TOKEN_PRIVMSG " %s :[%02d:%02d:%02d] %s", cs.num, bot.pchan, ntime->tm_hour,
		ntime->tm_min, ntime->tm_sec, buf);
	return;
}

void csmode(aChan *chan, int type, const char *fmt, ...)
{
	char buf[512], mode[50] = {0}, key[KEYLEN + 1] = {0}, limit[12] = {0};
	char *tmp = buf, *last = NULL, *tmp2 = NULL;
	int w = 1, cur = 0;

	va_list vl;
	va_start(vl, fmt);
	vsnprintf(buf, sizeof buf, fmt, vl);
	va_end(vl);
	putserv("%s " TOKEN_MODE " %s %s", cs.num, chan->chan, buf);

	if(type == MODE_OBV) return; /* modes passs uniquement +ovb pas de maj requise*/

	Strtok(&tmp2, tmp, ' ');

	for(;*tmp && cur < 50;tmp++)
	{ /*parsage des modes & filtrage des +ovb & obtention du n des param de key/limite*/
		switch(*tmp)
		{
			case 'o': case 'v': case 'b': /*ignore*/
				Strtok(&tmp2, NULL, ' ');
				break;
			case 'k':
			    last = Strtok(&tmp2, NULL, ' ');
				if(!key[0] && last) Strncpy(key, last, KEYLEN); /* on garde que la premire key cas +kkk*/
				mode[cur++] = *tmp;
				break;
			case 'l':
				if(w)
				{
					last = Strtok(&tmp2, NULL, ' ');
					if(!limit[0] && last) Strncpy(limit, last, sizeof limit - 1);
				}
				mode[cur++] = *tmp;
				break;
			case '-': w = 0; mode[cur++] = *tmp; break;
			case '+': w = 1; mode[cur++] = *tmp; break;
			default:
				mode[cur++] = *tmp;	break;
		}
	}

	string2scmode(&chan->mode, mode, key, limit);
	return;
}

void cstopic(aChan *chan, const char *topic)
{
#ifdef N2K
	putserv("%s " TOKEN_TOPIC " %s %lu :%s", cs.num, chan->chan, time(NULL), topic);
#else
	putserv("%s " TOKEN_TOPIC " %s :%s", cs.num, chan->chan, topic);
#endif
	strcpy(chan->topic, topic);
}

void cskick(const char *chan, const char *vict, const char *fmt, ...)
{
	char buf[512];
	va_list vl;

	va_start(vl, fmt);
	vsnprintf(buf, sizeof buf, fmt, vl);
	va_end(vl);
	putserv("%s " TOKEN_KICK " %s %s :%s", cs.num, chan, vict, buf);
}

void cswallops(const char *pattern, ...)
{
	char buf[350];
	va_list vl;

	va_start(vl, pattern);
	vsnprintf(buf, sizeof buf, pattern, vl);
	va_end(vl);
	putserv("%s " TOKEN_WALLOPS " :%s", cs.num, buf);
}

void csjoin(aChan *chan)
{
	register aNick *n;
	register aJoin *j;
	int i = 0;

	if(chan->members)/* on purge la nicklist du salon (si..) */
	{
		aLink *l, *lp = chan->members;
		for(;lp;lp = l)
		{
			l = lp->next;
			free(lp);
		}
		chan->users = 1;
		chan->members = NULL;
	}
	for(;i < NICKHASHSIZE;i++) for(n = nick_tab[i];n;n = n->next) /* chargement de la userlist HUGE load*/
		for(j = n->joinhead;j;j = j->next)
			if(!strcasecmp(chan->chan, j->channel))
			{	 /* on a trouv le bon chan hh */
				aLink *lp = calloc(1, sizeof(aLink));
				lp->value.j = j;
				lp->next = chan->members;
				chan->members = lp;
				chan->users++;
				j->chan = chan; /* on met  jour le pointeur */
				break;
			}

 	if(!chan->members) putserv("%s " TOKEN_CREATE " %s %lu", cs.num, chan->chan, time(NULL));
	else/* auto op Create ou Join/+o*/
	{
		putserv("%s " TOKEN_JOIN " %s", cs.num, chan->chan);
		csmode(chan, 0, "+o-ipsmrOlkcC %s *", cs.num);/* je peux pas savoir quels modes tait en place*/
	}
	if(chan->defmodes.modes) csmode(chan, 0, "+%s", GetCModes(chan->defmodes));
	SetCJoined(chan);
}

void cspart(aChan *chan, const char *raison)
{
	aLink *l, *lp = chan->members;

	for(;lp;lp = l)/* nettoyage des chan members */
	{
		lp->value.j->chan = NULL; /* le salon n'est plus reg.. (sauf si part.)*/
		l = lp->next;
		free(lp);
	}
	chan->users = 1;
	chan->members = NULL;
	DelCJoined(chan);
	putserv("%s " TOKEN_PART " %s :%s", cs.num, chan->chan, raison);
}

void cs_account(aNick *nick, const char *account)
{
	if(!account && nick->user)
	{
		if(nick->user->n == nick) nick->user->n = NULL;
		nick->user = NULL;
	}
#ifdef N2K
	putserv("%s " TOKEN_ACCOUNT " %s %s", bot.servnum, nick->numeric, NONE(account));
#else
	putserv(":%s " TOKEN_ACCOUNT " %s %s", cs.nick, nick->numeric, NONE(account));
#endif
	return;
}
