/* src/divers.c - Diverses commandes
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: divers.c,v 1.43 2003/12/27 16:19:26 romexzf Exp $
 */

#include "main.h"
#include "version.h"
#include "divers.h"
#include "config.h"
#include "outils.h"
#include "hash.h"
#include "del_info.h"
#include "cs_cmds.h"

int uptime(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	return csntc(nick, "Les services sont en ligne depuis %s", duration(time(NULL) - bot.uptime));
}

int ctcp_ping(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(parc) csntc(nick, "%cPING %s", CTCP_DELIM_CHAR, parv[1]);
	return 1;
}

int ctcp_version(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
    csntc(nick, "%cVERSION Services CoderZ " SPVERSION "(CVS-" CVSVERSION ")  Inter System (Build " __DATE__ " "__TIME__ ")%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
    csntc(nick, "%cVERSION   Progs <Progs@Inter-System.Net>%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
    csntc(nick, "%cVERSION   Cesar <Cesar@Inter-System.Net>%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
    csntc(nick, "%cVERSION   kouak <kouak@kouak.org>%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
    csntc(nick, "%cVERSION   http://coderz.inter-system.net%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
	return 1;
}

int lastseen(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *u = getuserinfo(parv[1]);

	if(!u) csntc(nick, GetReply(nick, L_NOSUCHUSER), parv[1]);
	else if(u->n) csntc(nick, "%s est actuellement logu", u->nick);
	else csntc(nick, "Dernier Login de %s il y a %s (%s)", u->nick, duration(time(NULL) - u->lastseend), get_time(u->lastseend));
	return 1;
}

int show_admins(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(getoption("-all", parv, parc, 1, -1))
	{
		anUser *u;
		int i = 0;
		csntc(nick, "\2Prsent  Niveau  Username       Pseudo\2");
		for(;i < USERHASHSIZE;i++) for(u = user_tab[i];u;u = u->next)
			if(IsAnAdmin(u) && (u->level != 4 || !GetConf(CF_HIDE_ADML4)))
				csntc(nick, "\2\003%s\2\3      %d       %-13s  \0032%s\3",
					u->n ? (u->n->flag & N_AWAY) ? "14ABS" : "3OUI" : "4NON",
					u->level, u->nick, u->n ? u->n->nick : "");
	}
	else
	{
		aLink *lp;
		char nicks[201] = {0};
		int size = 0;

		if(!(chaninfo = getchaninfo(bot.chan)))
		{
			csntc(nick, "Erreur, salon %s non enregistr, veuillez avertir un admin", bot.chan);
			cswallops("ERREUR : Le salon d'aide %s n'est pas enregistr.", bot.chan);
			return 0;
		}
		for(lp = chaninfo->members;lp;lp = lp->next)
		{
			int tmps = size, p;
			if(!lp->value.j->nick->user || !IsAnAdmin(lp->value.j->nick->user) ||
				 lp->value.j->nick->flag & N_AWAY || (GetConf(CF_HIDE_ADML4) && lp->value.j->nick->user->level == 4))
				   continue;
			size += (p = strlen(lp->value.j->nick->nick));
			if(size >= 200)
			{
				csntc(nick, "\2Administrateurs de %s actuellement disponibles:\2", cs.nick);
				csntc(nick, "  %s", nicks);
				size = p;
				strcpy(nicks, lp->value.j->nick->nick);
			}
			else strcpy(&nicks[tmps], lp->value.j->nick->nick);
			nicks[size++] = ' ';
			nicks[size] = 0;
		}
		if(!*nicks) return csntc(nick, "\2Aucun Administrateur de %s n'est actuellement disponible.\2", cs.nick);
		csntc(nick, "\2Administrateurs de %s actuellement disponibles:\2", cs.nick);
		csntc(nick, "  %s", nicks);
	}
	return 1;
}

int show_ignores(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct ignore *i= ignorehead, *it;
	time_t p = time(NULL);
	int c = 0;

	if(!ignorehead) return csntc(nick, GetReply(nick, L_NOINFOAVAILABLE));

	csntc(nick, "List des Ignors:");
	for(;i;i = it)
	{
		it = i->next;
		if(i->exp > p) csntc(nick,"\002%d\2. \2%s\2 Expire dans %s",++c, i->host, duration(i->exp - p));
		else del_ignore(i->host);
	}
	return 1;
}

int list_badnicks(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct badnicks *current = badnhead;

	if(!badnhead) return csntc(nick, GetReply(nick, L_NOINFOAVAILABLE));

	csntc(nick, "\2Liste des pseudo illgaux :");
	for(;current;current = current->next)
		csntc(nick, "  \002%s\2: %s", current->chaine, current->flag & CF_NOREG ? "NoReg" : "Pseudo interdit");
    return 1;
}

int list_badchans(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct badchans *current = badchead;

	if(!badchead) return csntc(nick, GetReply(nick, L_NOINFOAVAILABLE));

	csntc(nick, "\2Liste des salons illgaux :");
	for(;current;current = current->next) csntc(nick, "  \002%s\2 : %s", current->chaine, current->raison);
    return 1;
}
